:FIRSTROW
@echo off

rem
rem EnigmaM4 Simulator for Win32 Command Line
rem Created by Alberto Bernasconi
rem afb4 AT bluewin DOT ch
rem Version 1.0
rem August 2013
rem

setlocal

set _FileName=%~nx0
if [%1]==[] goto :SYNTAX

:::::::::
:SETTINGS
:::::::::

set _Trace=OFF
set _Syntax=NO
set _Output=MORE
set _MaxParm=20

call :INITIALSETTINGS1

:PARMLOOP
shift
if [%0] NEQ [] call :PARSEPARM %0

set /A _MaxParm-=1
if %_MaxParm% GTR 0 goto :PARMLOOP

call :CHECKPARM
if [%_Syntax%]==[YES] cls
if [%_Syntax%]==[YES] echo %_CheckParm%
if [%_Syntax%]==[YES] goto :SYNTAX

call :INITIALSETTINGS2

:::::
:MAIN
:::::

call :SETWIRINGS
if [%_Syntax%]==[YES] cls
if [%_Syntax%]==[YES] echo %_CheckWiring%
if [%_Syntax%]==[YES] goto :SYNTAX

call :RINGOFFSETS

call :SETTURNOVERS

set _LoopCounter=0

set _RotorHistG=
set _RotorHistR=
set _RotorHistM=
set _RotorHistL=
set _EnigmaInput=
set _EnigmaOutput=

:MAINLOOP

set /A _LoopCounter+=1
call set _CurLet=%%_Text:~%_LoopCounter%,1%%
if [%_CurLet%] NEQ [] call :ENIGMALOOP %_CurLet%
if [%_CurLet%] NEQ [] goto :MAINLOOP

if [%_Output%] NEQ [SIMPLE] echo RotorG: %_RotorHistG%
if [%_Output%] NEQ [SIMPLE] echo RotorL: %_RotorHistL%
if [%_Output%] NEQ [SIMPLE] echo RotorM: %_RotorHistM%
if [%_Output%] NEQ [SIMPLE] echo RotorR: %_RotorHistR%
if [%_Output%] NEQ [SIMPLE] echo Input:  %_EnigmaInput%
if [%_Output%] NEQ [SIMPLE] echo Output: %_EnigmaOutput%
if [%_Output%] EQU [SIMPLE] echo %_EnigmaOutput%

goto :CONTMAIN

::::::::::::
:SUBROUTINES
::::::::::::

::----------
:ENIGMALOOP
::----------
call :ECHOVAR Sub ENIGMALOOP start

:: Step RotorM (Double Stepping)
if [%_CurPosM_A%]==[%_TO1RotM%] set /A _CurPosL_N+=1
call :NUM2LET %_CurPosL_N% _CurPosL_A

if [%_CurPosM_A%]==[%_TO1RotM%] set /A _CurPosM_N+=1
call :NUM2LET %_CurPosM_N% _CurPosM_A

if [%_CurPosM_A%]==[%_TO2RotM%] set /A _CurPosL_N+=1
call :NUM2LET %_CurPosL_N% _CurPosL_A

if [%_CurPosM_A%]==[%_TO2RotM%] set /A _CurPosM_N+=1
call :NUM2LET %_CurPosM_N% _CurPosM_A
:: Step RotorM (Double Stepping)

:: Step RotorR 
if [%_CurPosR_A%]==[%_TO1RotR%] set /A _CurPosM_N+=1
call :NUM2LET %_CurPosM_N% _CurPosM_A

if [%_CurPosR_A%]==[%_TO2RotR%] set /A _CurPosM_N+=1
call :NUM2LET %_CurPosM_N% _CurPosM_A
:: Step RotorR 

set /A _CurPosR_N+=1
if %_CurPosR_N% GTR 26 set _CurPosR_N=1
call :NUM2LET %_CurPosR_N% _CurPosR_A

:: Plugboard Input
set _PlugFirstIn_A=%1
call :LET2NUM %_PlugFirstIn_A% _PlugFirstIn_N

call set _PlugFirstOut_A=%%_Plugboard:~%_PlugFirstIn_N%,1%%
call :ECHOVAR %_PlugFirstOut_A%

call :PASSROTR %_PlugFirstOut_A%
call :PASSROTM %_SignalOutR_A%
call :PASSROTL %_SignalOutM_A%
call :PASSROTG %_SignalOutL_A%
call :PASSREFL %_SignalOutG_A%
call :PASSROTREVG %_SignalOutRefl_A%
call :PASSROTREVL %_SignalOutRevG_A%
call :PASSROTREVM %_SignalOutRevL_A%
call :PASSROTREVR %_SignalOutRevM_A%

:: Plugboard Output
set _PlugLastIn_A=%_SignalOutRevR_A%
call :LET2NUM %_PlugLastIn_A% _PlugLastIn_N

call set _PlugLastOut_A=%%_Plugboard:~%_PlugLastIn_N%,1%%
call :ECHOVAR %_PlugLastOut_A%

if [%_Output%] NEQ [SIMPLE] echo in %_PlugFirstIn_A% out %_PlugLastOut_A%

set _RotorHistG=%_RotorHistG%%_CurPosG_A%
set _RotorHistR=%_RotorHistR%%_CurPosR_A%
set _RotorHistM=%_RotorHistM%%_CurPosM_A%
set _RotorHistL=%_RotorHistL%%_CurPosL_A%
set _EnigmaInput=%_EnigmaInput%%_PlugFirstIn_A%
set _EnigmaOutput=%_EnigmaOutput%%_PlugLastOut_A%

call :ECHOVAR Sub ENIGMALOOP end
goto :EOF


::------
:ECHOVAR
::------

@echo off
if [%_Trace%]==[ON] echo %*

goto :EOF


::----------
:RINGOFFSETS
::----------
call :ECHOVAR Sub RINGOFFSETS start

call :RINGOFFSET %_RinG_N% _RingOffsetG
call :RINGOFFSET %_RinR_N% _RingOffsetR
call :RINGOFFSET %_RinM_N% _RingOffsetM
call :RINGOFFSET %_RinL_N% _RingOffsetL

call :ECHOVAR _RingOffsetG %_RingOffsetG%
call :ECHOVAR _RingOffsetR %_RingOffsetR%
call :ECHOVAR _RingOffsetM %_RingOffsetM%
call :ECHOVAR _RingOffsetL %_RingOffsetL%

call :ECHOVAR Sub RINGOFFSETS end
goto :EOF


::---------
:RINGOFFSET
::---------
call :ECHOVAR Sub RINGOFFSET start

set /A %2=27-%1
if [%1] == [1] set %2=0

call :ECHOVAR Sub RINGOFFSET end
goto :EOF


::------
:LET2NUM
::------

if [%1] == [A] set %2=1
if [%1] == [B] set %2=2
if [%1] == [C] set %2=3
if [%1] == [D] set %2=4
if [%1] == [E] set %2=5
if [%1] == [F] set %2=6
if [%1] == [G] set %2=7
if [%1] == [H] set %2=8
if [%1] == [I] set %2=9
if [%1] == [J] set %2=10
if [%1] == [K] set %2=11
if [%1] == [L] set %2=12
if [%1] == [M] set %2=13
if [%1] == [N] set %2=14
if [%1] == [O] set %2=15
if [%1] == [P] set %2=16
if [%1] == [Q] set %2=17
if [%1] == [R] set %2=18
if [%1] == [S] set %2=19
if [%1] == [T] set %2=20
if [%1] == [U] set %2=21
if [%1] == [V] set %2=22
if [%1] == [W] set %2=23
if [%1] == [X] set %2=24
if [%1] == [Y] set %2=25
if [%1] == [Z] set %2=26

goto :EOF


::------
:NUM2LET
::------

call set %2=%%_LettersAZ:~%1,1%%

goto :EOF


::--------
:SIGNALOUT
::--------

set /A %4=%1-%2
if %4 LSS 0 set /A %4=26+%4
set /A %4=%4+%3

goto :EOF


::--------
:PARSEPARM
::--------
call :ECHOVAR Sub PARSEPARM start

set _parm=%1
call :ECHOVAR _parm: %_parm%
set _parm2=%_parm:~0,2%
call :ECHOVAR _parm2 %_parm2%

if [%_parm2%]==[RF] set _Refl=%_parm:~-1%
if [%_parm2%]==[RF] call :ECHOVAR %_Refl%

if [%_parm2%]==[RO] set _Rotors=%_parm:~-4%
if [%_parm2%]==[RO] call :ECHOVAR %_Rotors%

if [%_parm2%]==[PO] set _Positions=%_parm:~-4%
if [%_parm2%]==[PO] call :ECHOVAR %_Positions%

if [%_parm2%]==[RI] set _Rings=%_parm:~-4%
if [%_parm2%]==[RI] call :ECHOVAR %_Rings%

if [%_parm2%]==[PL] set _PlugPair=%_parm:~-2%
if [%_parm2%]==[PL] call :ECHOVAR %_PlugPair%
if [%_parm2%]==[PL] set _Plug1_A=%_PlugPair:~0,1%
if [%_parm2%]==[PL] set _Plug2_A=%_PlugPair:~1,1%
if [%_parm2%]==[PL] call :LET2NUM %_Plug1_A% _Plug1_N
if [%_parm2%]==[PL] call :LET2NUM %_Plug2_A% _Plug2_N
if [%_parm2%]==[PL] call set _Plugboard=%%_Plugboard:%_Plug1_A%=1%%
if [%_parm2%]==[PL] call set _Plugboard=%%_Plugboard:%_Plug2_A%=2%%
if [%_parm2%]==[PL] call set _Plugboard=%%_Plugboard:2=%_Plug1_A%%%
if [%_parm2%]==[PL] call set _Plugboard=%%_Plugboard:1=%_Plug2_A%%%
if [%_parm2%]==[PL] call :ECHOVAR %_Plugboard%

if [%_parm2%]==[TE] set _Text=#%_parm:~3%
if [%_parm2%]==[TE] call :ECHOVAR %_Text%

if [%_parm2%]==[TR] set _Trace=%_parm:~-2%
if [%_parm2%]==[TR] call :ECHOVAR %_Trace%

if [%_parm2%]==[OU] set _Output=%_parm:~-6%
if [%_parm2%]==[OU] call :ECHOVAR %_Output%

call :ECHOVAR Sub PARSEPARM end
goto :EOF


::--------
:CHECKPARM
::--------
call :ECHOVAR Sub CHECKPARM start

if [%_Refl%] NEQ [] call :ECHOVAR %_Refl%
if [%_Refl%]==[] set _CheckParm=Reflector not set
if [%_Refl%]==[] set _Syntax=YES

if [%_Rotors%] NEQ [] call :ECHOVAR %_Rotors%
if [%_Rotors%]==[] set _CheckParm=Rotors not set
if [%_Rotors%]==[] set _Syntax=YES

if [%_Positions%] NEQ [] call :ECHOVAR %_Positions%
if [%_Positions%]==[] set _CheckParm=Positions not set
if [%_Positions%]==[] set _Syntax=YES

if [%_Rings%] NEQ [] call :ECHOVAR %_Rings%
if [%_Rings%]==[] set _CheckParm=Rings not set
if [%_Rings%]==[] set _Syntax=YES

if [%_Text%] NEQ [] call :ECHOVAR %_Text%
if [%_Text%]==[] set _CheckParm=Text not set
if [%_Text%]==[] set _Syntax=YES

call :ECHOVAR Sub CHECKPARM end
goto :EOF


::---------------
:INITIALSETTINGS1
::---------------

set _RotWiring1=#EKMFLGDQVZNTOWYHXUSPAIBRCJ
set _RotWiring2=#AJDKSIRUXBLHWTMCQGZNPYFVOE
set _RotWiring3=#BDFHJLCPRTXVZNYEIWGAKMUSQO
set _RotWiring4=#ESOVPZJAYQUIRHXLNFTGKDCMWB
set _RotWiring5=#VZBRGITYUPSDNHLXAWMJQOFECK
set _RotWiring6=#JPGVOUMFYQBENHZRDKASXLICTW
set _RotWiring7=#NZJHGRCXMYSWBOUFAIVLPEKQDT
set _RotWiring8=#FKQHTLXOCBJSPDZRAMEWNIUYGV

set _RotWiringB=#LEYJVCNIXWPBQMDRTAKZGFUHOS
set _RotWiringG=#FSOKANUERHMBTIYCWLQPZXVGJD

set _ReflThinB=#ENKQAUYWJICOPBLMDXZVFTHRGS
set _ReflThinC=#RDOBJNTKVEHMLFCWZAXGYIPSUQ

set _RotWiringRevB=#RLFOBVUXHDSANGYKMPZQWEJICT
set _RotWiringRevG=#ELPZHAXJNYDRKFCTSIBMGWQVOU

set _RotWiringRev1=#UWYGADFPVZBECKMTHXSLRINQOJ
set _RotWiringRev2=#AJPCZWRLFBDKOTYUQGENHXMIVS
set _RotWiringRev3=#TAGBPCSDQEUFVNZHYIXJWLRKOM
set _RotWiringRev4=#HZWVARTNLGUPXQCEJMBSKDYOIF
set _RotWiringRev5=#QCYLXWENFTZOSMVJUDKGIARPHB
set _RotWiringRev6=#SKXQLHCNWARVGMEBJPTYFDZUIO
set _RotWiringRev7=#QMGYVPEDRCWTIANUXFKZOSLHJB
set _RotWiringRev8=#QJINSAYDVKBFRUHMCPLEWZTGXO

set _TurnOver1Rot1=Q
set _TurnOver2Rot1=#
set _TurnOver1Rot2=E
set _TurnOver2Rot2=#
set _TurnOver1Rot3=V
set _TurnOver2Rot3=#
set _TurnOver1Rot4=J
set _TurnOver2Rot4=#
set _TurnOver1Rot5=Z
set _TurnOver2Rot5=#
set _TurnOver1Rot6=Z
set _TurnOver2Rot6=M
set _TurnOver1Rot7=Z
set _TurnOver2Rot7=M
set _TurnOver1Rot8=Z
set _TurnOver2Rot8=M

set _PlugBoard=#ABCDEFGHIJKLMNOPQRSTUVWXYZ

set _LettersAZ=#ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZ

goto :EOF


::---------------
:INITIALSETTINGS2
::---------------
call :ECHOVAR Sub INITIALSETTINGS2 start

set _RotG_N=%_Rotors:~0,1%
set _RotL_N=%_Rotors:~1,1%
set _RotM_N=%_Rotors:~2,1%
set _RotR_N=%_Rotors:~3,1%

set _PosG_A=%_Positions:~0,1%
set _PosL_A=%_Positions:~1,1%
set _PosM_A=%_Positions:~2,1%
set _PosR_A=%_Positions:~3,1%

set _RinG_A=%_Rings:~0,1%
set _RinL_A=%_Rings:~1,1%
set _RinM_A=%_Rings:~2,1%
set _RinR_A=%_Rings:~3,1%

call :ECHOVAR %_Refl%
call :ECHOVAR %_RotG_N%
call :ECHOVAR %_RotL_N%
call :ECHOVAR %_RotM_N%
call :ECHOVAR %_RotR_N%
call :ECHOVAR %_PosG_A%
call :ECHOVAR %_PosL_A%
call :ECHOVAR %_PosM_A%
call :ECHOVAR %_PosR_A%
call :ECHOVAR %_RinG_A%
call :ECHOVAR %_RinL_A%
call :ECHOVAR %_RinM_A%
call :ECHOVAR %_RinR_A%

call :LET2NUM %_PosG_A% _PosG_N
call :LET2NUM %_PosL_A% _PosL_N
call :LET2NUM %_PosM_A% _PosM_N
call :LET2NUM %_PosR_A% _PosR_N
call :LET2NUM %_RinG_A% _RinG_N
call :LET2NUM %_RinL_A% _RinL_N
call :LET2NUM %_RinM_A% _RinM_N
call :LET2NUM %_RinR_A% _RinR_N

call :ECHOVAR %_PosG_N%
call :ECHOVAR %_PosL_N%
call :ECHOVAR %_PosM_N%
call :ECHOVAR %_PosR_N%
call :ECHOVAR %_RinG_N%
call :ECHOVAR %_RinL_N%
call :ECHOVAR %_RinM_N%
call :ECHOVAR %_RinR_N%

set _CurPosG_N=%_PosG_N%
set _CurPosR_N=%_PosR_N%
set _CurPosM_N=%_PosM_N%
set _CurPosL_N=%_PosL_N%

call :NUM2LET %_CurPosG_N% _CurPosG_A
call :NUM2LET %_CurPosR_N% _CurPosR_A
call :NUM2LET %_CurPosM_N% _CurPosM_A
call :NUM2LET %_CurPosL_N% _CurPosL_A

call :ECHOVAR Sub INITIALSETTINGS2 end
goto :EOF


::---------
:SETWIRINGS
::---------
call :ECHOVAR Sub SETWIRINGS start

::RotorG
call set _RotWiringG=%%_RotWiring%_RotG_N%%%
set _RotWiringG_type=_RotWiring%_RotG_N%
call :ECHOVAR RotorG
call :ECHOVAR %_RotWiringG_type%
call :ECHOVAR %_RotWiringG%
if [%_RotWiringG%]==[] set _CheckWiring=Rotor %_RotG_N% does not exist
if [%_RotWiringG%]==[] set _Syntax=YES

::RotorR
call set _RotWiringR=%%_RotWiring%_RotR_N%%%
set _RotWiringR_type=_RotWiring%_RotR_N%
call :ECHOVAR RotorR
call :ECHOVAR %_RotWiringR_type%
call :ECHOVAR %_RotWiringR%
if [%_RotWiringR%]==[] set _CheckWiring=Rotor %_RotR_N% does not exist
if [%_RotWiringR%]==[] set _Syntax=YES

::RotorM
call set _RotWiringM=%%_RotWiring%_RotM_N%%%
set _RotWiringM_type=_RotWiring%_RotM_N%
call :ECHOVAR RotorM
call :ECHOVAR %_RotWiringM_type%
call :ECHOVAR %_RotWiringM%
if [%_RotWiringM%]==[] set _CheckWiring=Rotor %_RotM_N% does not exist
if [%_RotWiringM%]==[] set _Syntax=YES

::RotorL
call set _RotWiringL=%%_RotWiring%_RotL_N%%%
set _RotWiringL_type=_RotWiring%_RotL_N%
call :ECHOVAR RotorL
call :ECHOVAR %_RotWiringL_type%
call :ECHOVAR %_RotWiringL%
if [%_RotWiringL%]==[] set _CheckWiring=Rotor %_RotL_N% does not exist
if [%_RotWiringL%]==[] set _Syntax=YES

::Reflector
call set _ReflWiring=%%_ReflThin%_Refl%%%
set _ReflWiring_type=_ReflThin%_Refl%
call :ECHOVAR Reflector
call :ECHOVAR %_ReflWiring_type%
call :ECHOVAR %_ReflWiring%
if [%_ReflWiring%]==[] set _CheckWiring=Reflector %_Refl% does not exist
if [%_ReflWiring%]==[] set _Syntax=YES

::RotorRevG
call set _RotWiringRevG=%%_RotWiringRev%_RotG_N%%%
set _RotWiringRevG_type=_RotWiringRev%_RotG_N%
call :ECHOVAR RotorRevG
call :ECHOVAR %_RotWiringRevG_type%
call :ECHOVAR %_RotWiringRevG%

::RotorRevR
call set _RotWiringRevR=%%_RotWiringRev%_RotR_N%%%
set _RotWiringRevR_type=_RotWiringRev%_RotR_N%
call :ECHOVAR RotorRevR
call :ECHOVAR %_RotWiringRevR_type%
call :ECHOVAR %_RotWiringRevR%

::RotorRevM
call set _RotWiringRevM=%%_RotWiringRev%_RotM_N%%%
set _RotWiringRevM_type=_RotWiringRev%_RotM_N%
call :ECHOVAR RotorRevM
call :ECHOVAR %_RotWiringRevM_type%
call :ECHOVAR %_RotWiringRevM%

::RotorRevL
call set _RotWiringRevL=%%_RotWiringRev%_RotL_N%%%
set _RotWiringRevL_type=_RotWiringRev%_RotL_N%
call :ECHOVAR RotorRevL
call :ECHOVAR %_RotWiringRevL_type%
call :ECHOVAR %_RotWiringRevL%

call :ECHOVAR Sub SETWIRINGS end
goto :EOF


::-----------
:SETTURNOVERS
::-----------
call :ECHOVAR Sub SETTURNOVERS start

::TurnOver1RotorR
call set _TO1RotR=%%_TurnOver1Rot%_RotR_N%%%
set _TO1RotR_type=_TurnOver1Rot%_RotR_N%
call :ECHOVAR _TO1RotR
call :ECHOVAR %_TO1RotR_type%
call :ECHOVAR %_TO1RotR%

::TurnOver2RotorR
call set _TO2RotR=%%_TurnOver2Rot%_RotR_N%%%
set _TO2RotR_type=_TurnOver2Rot%_RotR_N%
call :ECHOVAR _TO2RotR
call :ECHOVAR %_TO2RotR_type%
call :ECHOVAR %_TO2RotR%

::TurnOver1RotorM
call set _TO1RotM=%%_TurnOver1Rot%_RotM_N%%%
set _TO1RotM_type=_TurnOver1Rot%_RotM_N%
call :ECHOVAR _TO1RotM
call :ECHOVAR %_TO1RotM_type%
call :ECHOVAR %_TO1RotM%

::TurnOver2RotorM
call set _TO2RotM=%%_TurnOver2Rot%_RotM_N%%%
set _TO2RotM_type=_TurnOver2Rot%_RotM_N%
call :ECHOVAR _TO2RotM
call :ECHOVAR %_TO2RotM_type%
call :ECHOVAR %_TO2RotM%

call :ECHOVAR Sub SETTURNOVERS end
goto :EOF


:PASSROTR
call :ECHOVAR Sub PASSROTR start

set _SignalInR_A=%1
call :ECHOVAR %_SignalInR_A%
call :LET2NUM %_SignalInR_A% _SignalInR_N
call :ECHOVAR %_SignalInR_N%

set /A _ContactInR_N=%_CurPosR_N%+%_RingOffsetR%+%_SignalInR_N%-1
set /A _ContactInR_N=%_ContactInR_N% %%26
call :ECHOVAR %_ContactInR_N%
if [%_ContactInR_N%]==[0] set _ContactInR_N=26
call :ECHOVAR %_ContactInR_N%
call :NUM2LET %_ContactInR_N% _ContactInR_A
call :ECHOVAR %_ContactInR_A%

call set _ContactOutR_A=%%_RotWiringR:~%_ContactInR_N%,1%%
call :ECHOVAR %_ContactOutR_A%
call :LET2NUM %_ContactOutR_A% _ContactOutR_N
call :ECHOVAR %_ContactOutR_N%

call :SIGNALOUT %_ContactOutR_N% %_ContactInR_N% %_SignalInR_N% _SignalOutR_N
call :ECHOVAR %_SignalOutR_N%
call :NUM2LET %_SignalOutR_N% _SignalOutR_A
call :ECHOVAR %_SignalOutR_A%

call :ECHOVAR Sub PASSROTR end
goto :EOF


:PASSROTM
call :ECHOVAR Sub PASSROTM start

set _SignalInM_A=%1
call :ECHOVAR %_SignalInM_A%
call :LET2NUM %_SignalInM_A% _SignalInM_N
call :ECHOVAR %_SignalInM_N%

set /A _ContactInM_N=%_CurPosM_N%+%_RingOffsetM%+%_SignalInM_N%-1
set /A _ContactInM_N=%_ContactInM_N% %%26
call :ECHOVAR %_ContactInM_N%
if [%_ContactInM_N%]==[0] set _ContactInM_N=26
call :ECHOVAR %_ContactInM_N%
call :NUM2LET %_ContactInM_N% _ContactInM_A
call :ECHOVAR %_ContactInM_A%

call set _ContactOutM_A=%%_RotWiringM:~%_ContactInM_N%,1%%
call :ECHOVAR %_ContactOutM_A%
call :LET2NUM %_ContactOutM_A% _ContactOutM_N
call :ECHOVAR %_ContactOutM_N%

call :SIGNALOUT %_ContactOutM_N% %_ContactInM_N% %_SignalInM_N% _SignalOutM_N
call :ECHOVAR %_SignalOutM_N%
call :NUM2LET %_SignalOutM_N% _SignalOutM_A
call :ECHOVAR %_SignalOutM_A%

call :ECHOVAR Sub PASSROTM end
goto :EOF


:PASSROTL
call :ECHOVAR Sub PASSROTL start

set _SignalInL_A=%1
call :ECHOVAR %_SignalInL_A%
call :LET2NUM %_SignalInL_A% _SignalInL_N
call :ECHOVAR %_SignalInL_N%

set /A _ContactInL_N=%_CurPosL_N%+%_RingOffsetL%+%_SignalInL_N%-1
set /A _ContactInL_N=%_ContactInL_N% %%26
call :ECHOVAR %_ContactInL_N%
if [%_ContactInL_N%]==[0] set _ContactInL_N=26
call :ECHOVAR %_ContactInL_N%
call :NUM2LET %_ContactInL_N% _ContactInL_A
call :ECHOVAR %_ContactInL_A%

call set _ContactOutL_A=%%_RotWiringL:~%_ContactInL_N%,1%%
call :ECHOVAR %_ContactOutL_A%
call :LET2NUM %_ContactOutL_A% _ContactOutL_N
call :ECHOVAR %_ContactOutL_N%

call :SIGNALOUT %_ContactOutL_N% %_ContactInL_N% %_SignalInL_N% _SignalOutL_N
call :ECHOVAR %_SignalOutL_N%
call :NUM2LET %_SignalOutL_N% _SignalOutL_A
call :ECHOVAR %_SignalOutL_A%

call :ECHOVAR Sub PASSROTL end
goto :EOF


:PASSROTG
call :ECHOVAR Sub PASSROTG start

set _SignalInG_A=%1
call :ECHOVAR %_SignalInG_A%
call :LET2NUM %_SignalInG_A% _SignalInG_N
call :ECHOVAR %_SignalInG_N%

set /A _ContactInG_N=%_CurPosG_N%+%_RingOffsetG%+%_SignalInG_N%-1
set /A _ContactInG_N=%_ContactInG_N% %%26
call :ECHOVAR %_ContactInG_N%
if [%_ContactInG_N%]==[0] set _ContactInG_N=26
call :ECHOVAR %_ContactInG_N%
call :NUM2LET %_ContactInG_N% _ContactInG_A
call :ECHOVAR %_ContactInG_A%

call set _ContactOutG_A=%%_RotWiringG:~%_ContactInG_N%,1%%
call :ECHOVAR %_ContactOutG_A%
call :LET2NUM %_ContactOutG_A% _ContactOutG_N
call :ECHOVAR %_ContactOutG_N%

call :SIGNALOUT %_ContactOutG_N% %_ContactInG_N% %_SignalInG_N% _SignalOutG_N
call :ECHOVAR %_SignalOutG_N%
call :NUM2LET %_SignalOutG_N% _SignalOutG_A
call :ECHOVAR %_SignalOutG_A%

call :ECHOVAR Sub PASSROTG end
goto :EOF


:PASSREFL
call :ECHOVAR Sub PASSREFL start

set _SignalInRefl_A=%1
call :ECHOVAR %_SignalInRefl_A%
call :LET2NUM %_SignalInRefl_A% _SignalInRefl_N
call :ECHOVAR %_SignalInRefl_N%

call set _SignalOutRefl_A=%%_ReflWiring:~%_SignalInRefl_N%,1%%
call :ECHOVAR %_SignalOutRefl_A%

call :ECHOVAR Sub PASSREFL end
goto :EOF


:PASSROTREVG
call :ECHOVAR Sub PASSROTREVG start

set _SignalInRevG_A=%1
call :ECHOVAR %_SignalInRevG_A%
call :LET2NUM %_SignalInRevG_A% _SignalInRevG_N
call :ECHOVAR %_SignalInRevG_N%

set /A _ContactInRevG_N=%_CurPosG_N%+%_RingOffsetG%+%_SignalInRevG_N%-1
set /A _ContactInRevG_N=%_ContactInRevG_N% %%26
call :ECHOVAR %_ContactInRevG_N%
if [%_ContactInRevG_N%]==[0] set _ContactInRevG_N=26
call :ECHOVAR %_ContactInRevG_N%
call :NUM2LET %_ContactInRevG_N% _ContactInRevG_A
call :ECHOVAR %_ContactInRevG_A%

call set _ContactOutRevG_A=%%_RotWiringRevG:~%_ContactInRevG_N%,1%%
call :ECHOVAR %_ContactOutRevG_A%
call :LET2NUM %_ContactOutRevG_A% _ContactOutRevG_N
call :ECHOVAR %_ContactOutRevG_N%

call :SIGNALOUT %_ContactOutRevG_N% %_ContactInRevG_N% %_SignalInRevG_N% _SignalOutRevG_N
call :ECHOVAR %_SignalOutRevG_N%
call :NUM2LET %_SignalOutRevG_N% _SignalOutRevG_A
call :ECHOVAR %_SignalOutRevG_A%

call :ECHOVAR Sub PASSROTREVG end
goto :EOF


:PASSROTREVL
call :ECHOVAR Sub PASSROTREVL start

set _SignalInRevL_A=%1
call :ECHOVAR %_SignalInRevL_A%
call :LET2NUM %_SignalInRevL_A% _SignalInRevL_N
call :ECHOVAR %_SignalInRevL_N%

set /A _ContactInRevL_N=%_CurPosL_N%+%_RingOffsetL%+%_SignalInRevL_N%-1
set /A _ContactInRevL_N=%_ContactInRevL_N% %%26
call :ECHOVAR %_ContactInRevL_N%
if [%_ContactInRevL_N%]==[0] set _ContactInRevL_N=26
call :ECHOVAR %_ContactInRevL_N%
call :NUM2LET %_ContactInRevL_N% _ContactInRevL_A
call :ECHOVAR %_ContactInRevL_A%

call set _ContactOutRevL_A=%%_RotWiringRevL:~%_ContactInRevL_N%,1%%
call :ECHOVAR %_ContactOutRevL_A%
call :LET2NUM %_ContactOutRevL_A% _ContactOutRevL_N
call :ECHOVAR %_ContactOutRevL_N%

call :SIGNALOUT %_ContactOutRevL_N% %_ContactInRevL_N% %_SignalInRevL_N% _SignalOutRevL_N
call :ECHOVAR %_SignalOutRevL_N%
call :NUM2LET %_SignalOutRevL_N% _SignalOutRevL_A
call :ECHOVAR %_SignalOutRevL_A%

call :ECHOVAR Sub PASSROTREVL end
goto :EOF


:PASSROTREVM
call :ECHOVAR Sub PASSROTREVM start

set _SignalInRevM_A=%1
call :ECHOVAR %_SignalInRevM_A%
call :LET2NUM %_SignalInRevM_A% _SignalInRevM_N
call :ECHOVAR %_SignalInRevM_N%

set /A _ContactInRevM_N=%_CurPosM_N%+%_RingOffsetM%+%_SignalInRevM_N%-1
set /A _ContactInRevM_N=%_ContactInRevM_N% %%26
call :ECHOVAR %_ContactInRevM_N%
if [%_ContactInRevM_N%]==[0] set _ContactInRevM_N=26
call :ECHOVAR %_ContactInRevM_N%
call :NUM2LET %_ContactInRevM_N% _ContactInRevM_A
call :ECHOVAR %_ContactInRevM_A%

call set _ContactOutRevM_A=%%_RotWiringRevM:~%_ContactInRevM_N%,1%%
call :ECHOVAR %_ContactOutRevM_A%
call :LET2NUM %_ContactOutRevM_A% _ContactOutRevM_N
call :ECHOVAR %_ContactOutRevM_N%

call :SIGNALOUT %_ContactOutRevM_N% %_ContactInRevM_N% %_SignalInRevM_N% _SignalOutRevM_N
call :ECHOVAR %_SignalOutRevM_N%
call :NUM2LET %_SignalOutRevM_N% _SignalOutRevM_A
call :ECHOVAR %_SignalOutRevM_A%

call :ECHOVAR Sub PASSROTREVM end
goto :EOF


:PASSROTREVR
call :ECHOVAR Sub PASSROTREVR start

set _SignalInRevR_A=%1
call :ECHOVAR %_SignalInRevR_A%
call :LET2NUM %_SignalInRevR_A% _SignalInRevR_N
call :ECHOVAR %_SignalInRevR_N%

set /A _ContactInRevR_N=%_CurPosR_N%+%_RingOffsetR%+%_SignalInRevR_N%-1
set /A _ContactInRevR_N=%_ContactInRevR_N% %%26
call :ECHOVAR %_ContactInRevR_N%
if [%_ContactInRevR_N%]==[0] set _ContactInRevR_N=26
call :ECHOVAR %_ContactInRevR_N%
call :NUM2LET %_ContactInRevR_N% _ContactInRevR_A
call :ECHOVAR %_ContactInRevR_A%

call set _ContactOutRevR_A=%%_RotWiringRevR:~%_ContactInRevR_N%,1%%
call :ECHOVAR %_ContactOutRevR_A%
call :LET2NUM %_ContactOutRevR_A% _ContactOutRevR_N
call :ECHOVAR %_ContactOutRevR_N%

call :SIGNALOUT %_ContactOutRevR_N% %_ContactInRevR_N% %_SignalInRevR_N% _SignalOutRevR_N
call :ECHOVAR %_SignalOutRevR_N%
call :NUM2LET %_SignalOutRevR_N% _SignalOutRevR_A
call :ECHOVAR %_SignalOutRevR_A%

call :ECHOVAR Sub PASSROTREVR end
goto :EOF

::-----
:SYNTAX
::-----
echo Usage:
echo %_FileName% RF_? RO_???? PO_???? RI_???? [PL_?? [PL_??] ..] TE_?[..] TR_?? OU_??????
echo.
echo Arguments (required):
echo RF reflector (B/C)
echo RO rotors    (1-8, B/C)
echo PO positions (A-Z)
echo RI rings     (A-Z)
echo TE text      (A-Z)
echo.
echo Arguments (optional):
echo PL plugboard pair (A-Z)
echo.
echo Options:
echo OU output (SIMPLE [OU_SIMPLE] output only, default rotors, input, output)
echo TR trace  (ON [TR_ON], default OFF)
echo.
echo Example:
echo EnigmaM4.bat RF_B RO_B241 RI_AAAV PL_AT PL_BL PL_DF PL_GJ PL_HM PL_NW PL_OP PL_QY PL_RZ PL_VX TE_NCZWVUSXPNYMINHZXMQX PO_VJNA

goto :CONTMAIN


:::::::::
:CONTMAIN
:::::::::

endlocal

:LASTROW
